=== assembler/ext/src/cityhash/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(cityhash CXX)

add_library(cityhash STATIC
            city.cc)
