=== debian/control ===
Source: spades
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>,
           Michael R. Crusoe <michael.crusoe@gmail.com>,
           Alexandre Mestiashvili <mestia@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-python,
               cmake,
               python3-dev,
               zlib1g-dev,
               libbz2-dev,
               libboost-dev,
               libbam-dev,
               libbamtools-dev,
               libhat-trie-dev,
               libhts-dev,
               libnlopt-dev,
               libnlopt-cxx-dev,
               libssw-dev,
               python3-yaml,
               python3-joblib,
               asciidoctor (>= 1.5.3),
               bwa,
               libbwa-dev,
               lynx
Standards-Version: 4.4.1
Vcs-Browser: https://salsa.debian.org/med-team/spades
Vcs-Git: https://salsa.debian.org/med-team/spades.git
Homepage: http://cab.spbu.ru/software/spades/

Package: spades
Architecture: any
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         python3,
         python3-distutils,
         python3-joblib,
         python3-yaml,
         bwa,
         bamtools,
         samtools,
         libnlopt0,
         libhat-trie0,
         libssw0
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.
