## spades 3.15.4+dfsg

=== debian/changelog ===
spades (3.15.4+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Lance Lin ]
  * d/patches/0003_accept-system-bwa.patch - refactored 'which'
    Closes: #1010788

  [ Andreas Tille ]
  * Review copyright

 -- Lance Lin <LQi254@protonmail.com>  Tue, 10 May 2022 20:15:40 +0700

spades (3.15.4+dfsg-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * New upstream version
  * Refreshed patches
  * debian/upstream/metadata: Added many missing papers
  * remove assembler/ext/src/llvm/ConvertUTF.cpp
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)

  [ Steffen Moeller ]
  * d/u/metadata
    - yamllint cleanliness
    - added ref to bioconda
  * Add salsa-ci file (routine-update)
  * Refer to common license file for Apache-2.0.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Upstream addressed / -> // in generate_quality (less nice, though)
  * Prepared PRs for spelling errors found by Michael

  [ Andreas Tille ]
  * Adjust patches
  * Remove redundant gbp.conf

  [ Juhani Numminen ]
  * Enable parallel builds by ignoring spades_compile.sh
    - Fix patches for the bypassing of spades_compile.sh
  * Remove gcc7.patch: applied upstream
  * python3.patch: add coronaspades.py and before_start_stage.py
  * Simplify debian/rules: do not attempt to run as-installed tests before
    installation
  * Install scripts under FHS-compliant path /usr/libexec/spades/
    - Adjust 0118_adjust_spades_home_again.patch
  * Add patches to make the test suite runnable
  * d/links: Add new binary coronaspades(.py)
  * Remove unused adapt_to_debian_pathes.patch
  * Add d/clean for test artifacts
  * Add disable_local_convertutf.patch: to cover for dfsg-removed ConvertUTF.o,
    link against system's LLVMSupport.a
  * Build-Deps: does not build python extensions; s/python3-dev/python3-all/
  * Depends: remove explicit shared libs (handled as ${shlibs:Depends})
  * Use vendored boost which has local modifications to avoid include problems
    during program use.

  [ Étienne Mollier ]
  * Add fix-sigill-on-non-popcnt-cpus.patch; fixes baseline violation.

  [ Andreas Tille ]
  * d/watch:
     - Fix to detect new versions on github (routine-update)
     - Use proper filename for download
  * Standards-Version: 4.6.0 (routine-update)
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on asciidoctor.

  [ Étienne Mollier ]
  * Adjust fix-sigill-on-non-popcnt-cpus.patch to not overflow on large int.
  * d/control: add myself to Uploaders.

 -- Étienne Mollier <emollier@debian.org>  Mon, 11 Apr 2022 21:30:33 +0200
