=== debian/control ===
--- 
+++ 
@@ -9,12 +9,16 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-python,
+               clang-format,
+               clang-tidy,
+               clang-tools,
                cmake,
                python3-all,
                zlib1g-dev,
                libbz2-dev,
                libbam-dev,
                libbamtools-dev,
+               libc++-dev,
                libhts-dev,
                libnlopt-dev,
                libnlopt-cxx-dev,
@@ -26,7 +30,7 @@
                bwa,
                libbwa-dev,
                lynx
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/spades
 Vcs-Git: https://salsa.debian.org/med-team/spades.git
 Homepage: http://cab.spbu.ru/software/spades/
